#include<bits/stdc++.h>
using namespace std;
pair<int, int> point[50001];
int tochki[100000];
int n,maxi=0, mini=10000000, br, f;
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>point[i].first>>point[i].second;
        mini=min(mini,point[i].first);
        maxi=max(maxi,point[i].second);
    }
    //sort(point,point+n);
    for(int i=mini; i<=maxi; i++)
    {
        for(int j=0; j<n and point[j].first<=i; j++)
        {
            if(point[j].second>i) br++;
        }
        if(tochki[br]==0) f++;
        tochki[br]++;
        br=0;
    }
   // sort(tochki, tochki+f+1);
    cout<<f-1<<"\n"<<tochki[f]<<"\n";
    return 0;
}
